
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ConversationsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const conversations = await db.conversations.create(
            {
                id: data.id || undefined,
        
        last_message: data.last_message
        ||
        null
            ,
            
        last_message_at: data.last_message_at
        ||
        null
            ,
            
        tutor_unread_count: data.tutor_unread_count
        ||
        null
            ,
            
        learner_unread_count: data.learner_unread_count
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await conversations.setTutor( data.tutor || null, {
            transaction,
        });
        
        await conversations.setLearner( data.learner || null, {
            transaction,
        });
        

        

        

        return conversations;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const conversationsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                last_message: item.last_message
            ||
            null
            ,
            
                last_message_at: item.last_message_at
            ||
            null
            ,
            
                tutor_unread_count: item.tutor_unread_count
            ||
            null
            ,
            
                learner_unread_count: item.learner_unread_count
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const conversations = await db.conversations.bulkCreate(conversationsData, { transaction });

        // For each item created, replace relation files
        

        return conversations;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const conversations = await db.conversations.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.last_message !== undefined) updatePayload.last_message = data.last_message;
        
        
        if (data.last_message_at !== undefined) updatePayload.last_message_at = data.last_message_at;
        
        
        if (data.tutor_unread_count !== undefined) updatePayload.tutor_unread_count = data.tutor_unread_count;
        
        
        if (data.learner_unread_count !== undefined) updatePayload.learner_unread_count = data.learner_unread_count;
        
        
        updatePayload.updatedById = currentUser.id;

        await conversations.update(updatePayload, {transaction});

        
        
        if (data.tutor !== undefined) {
            await conversations.setTutor(
              
              data.tutor,
              
              { transaction }
            );
        }
        
        if (data.learner !== undefined) {
            await conversations.setLearner(
              
              data.learner,
              
              { transaction }
            );
        }
        

        
        

        

        return conversations;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const conversations = await db.conversations.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of conversations) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of conversations) {
                await record.destroy({transaction});
            }
        });


        return conversations;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const conversations = await db.conversations.findByPk(id, options);

        await conversations.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await conversations.destroy({
            transaction
        });

        return conversations;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const conversations = await db.conversations.findOne(
            { where },
            { transaction },
        );

        if (!conversations) {
            return conversations;
        }

        const output = conversations.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.messages_conversation = await conversations.getMessages_conversation({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.tutor = await conversations.getTutor({
            transaction
        });
        
        
        output.learner = await conversations.getLearner({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'tutor',
        
        where: filter.tutor ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tutor.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.tutor.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'learner',
        
        where: filter.learner ? {
          [Op.or]: [
            { id: { [Op.in]: filter.learner.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.learner.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.last_message) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'conversations',
                        'last_message',
                        filter.last_message,
                    ),
                };
            }
            

            
            

            
            if (filter.last_message_atRange) {
                const [start, end] = filter.last_message_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    last_message_at: {
                    ...where.last_message_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    last_message_at: {
                    ...where.last_message_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.tutor_unread_countRange) {
                const [start, end] = filter.tutor_unread_countRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    tutor_unread_count: {
                    ...where.tutor_unread_count,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    tutor_unread_count: {
                    ...where.tutor_unread_count,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.learner_unread_countRange) {
                const [start, end] = filter.learner_unread_countRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    learner_unread_count: {
                    ...where.learner_unread_count,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    learner_unread_count: {
                    ...where.learner_unread_count,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.conversations.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'conversations',
                        'last_message',
                        query,
                    ),
                ],
            };
        }

        const records = await db.conversations.findAll({
            attributes: [ 'id', 'last_message' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['last_message', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.last_message,
        }));
    }

    
};

